#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/iocan128.h>
#include <avr/iocanxx.h>
#include <avr/eeprom.h>
#include <avr/wdt.h>
#include <avr/pgmspace.h>

#include "aladin_slave.h"
#include "define.h"
#include "global.h"

uint8_t TWIS_Init (uint8_t Address, uint32_t Bitrate)
	{
        /*set the TWI bitrate*/
        TWBR = ((F_CPU/Bitrate)-16)/2; 
	snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("TWBR: %d"),TWBR);
	UART0_Send_Message_String(tempstr);
	if (TWBR < 11) return FALSE;
       /* set the TWI slave address*/
	TWAR = (Address << 1);
       /* enable activate TWI interface and acknowledge*/
	TWCR = (1<<TWEN)|(1<<TWEA);
	return TRUE;
	}
	
void TWIS_Stop (void)
	{
	 TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO)|(1<<TWEA);
	 snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("stop funkion: %d"),TWEA);
         UART0_Send_Message_String(tempstr);
	}


void TWIS_Write (uint8_t byte)
	{
	TWDR = byte;
	snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("TWDR data: %x"),TWDR);
	UART0_Send_Message_String(tempstr);
	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWEA);
	while (!(TWCR & (1<<TWINT)));
	}



uint8_t	TWIS_ResonseRequired (uint8_t *TWI_ResonseType)
	{
// 	snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("*TWI_ResonseType: %x"),*TWI_ResonseType);
// 	UART0_Send_Message_String(tempstr);
	*TWI_ResonseType = TWSR;
	snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("TWSR nach: %x"),TWSR);
	UART0_Send_Message_String(tempstr);
	return TWCR & (1<<TWINT);
	}