#include <stdio.h>
#include <string.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/iocan128.h>
#include <avr/iocanxx.h>
#include <avr/pgmspace.h>
#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/eeprom.h>
#include <avr/wdt.h>
#include "define.h"
#include "global.h"
#include "aladin_slave.h"


volatile unsigned char uartReady;/*variable for Uart interrupt*/
char uartString[BUFFER_SIZE]; /* variable for storage received a complete string via UART */ 
char decrypt_uartString[BUFFER_SIZE]; 
char tempstr[BUFFER_SIZE];/*variable for debug*/
unsigned char nextCharPos; /*pointer of the variable uartString  */


int main(void)
{
	/* initialize flag */
	uint8_t i=0;
        uint8_t j=0xFF;
        uint8_t byte[8];
        uint8_t TWIS_ResonseType;
	nextCharPos = 0;
	uartReady = 0;
	cli();  /*interrupt disable */
	UART0_Init(); /* initialize serial interface */
	/* Start TWI Slave with address 158 and bitrate of 250000Hz*/
      
	TWIS_Init (158, 250000);
	
	sei(); /*interrupt enable */
	
	while( 1 ) 
	{
	          
		if( 1 == uartReady )/* of the ISR was completely receive a string */
		{  			
			cli();
			strncpy( decrypt_uartString, uartString,sizeof(decrypt_uartString));
 			snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("commando:%s"),decrypt_uartString);
 			UART0_Send_Message_String(tempstr);
			memset(uartString,0,sizeof(uartString));
			uartReady = 0; /* restore flag */
			sei();
		}
		
	/*Check wether something is to do for the TWI slave interface*/
		if (TWIS_ResonseRequired (&TWIS_ResonseType))
		{		
			switch (TWIS_ResonseType)
				{
/*
** Slave is requested to send bytes to the master.
** It is expliciltely assumed, that the master expects 8 bytes
*/
				case TWIS_WriteBytes:
					for (i=0;i<8;i++)
						{ 
						TWIS_Write (j++);
					        snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("Byte sent: %d"),j-1);
 			                        UART0_Send_Message_String(tempstr);
						}
				    TWIS_Stop ();
					break;
				}
		
	
		}/*do something*/
	 i++;
	}
 return 0;	
}	

	




